/*
 * flags.h - Flags for the revirt system.  May be included from .S file.
 *
 * Copyright (C) 2002 George Dunlap
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define REPLAY_UML_TAILORED 1

/* replay flags */
#define REPLAY_NONE   (0)
#define REPLAY_LOG    (1)
#define REPLAY_REPLAY (1 << 1)
#define REPLAY_SSTEP  (1 << 2)
#define REPLAY_START  (1 << 3)
#define REPLAY_PROCESS_IN_UMODE (1 << 4)
#define REPLAY_SCHEDPEND (1 << 5)
#define REPLAY_SYNC  (1 << 6)
#define REPLAY_WAIT (1 << 7)
#define REPLAY_AT_EXIT (1 << 8)
//#define REPLAY_NOTDONE (1 << 9)
#define REPLAY_SCHED (1 << 10)
#define REPLAY_IN_COPY_USER (1 << 11)
#define REPLAY_DATASQUASH (1 << 12)
#define REPLAY_XUSER (1 << 13) 
#define REPLAY_ZOMBIE (1 << 14)
#define REPLAY_SYSCALL (1 << 15)
#define REPLAY_PTRACE (1 << 16)
//#define REPLAY_NOSIG (1 << 17)

#define REPLAY_TSK_GETSTATE(x) (((x) >> 20) & 0xF)
#define REPLAY_TSK_SETSTATE(x) (((x) & 0xF) << 20)
