/*
 * include/revirt/rlog_min.h :
 * 
 * To be included by .h files included by many other files; i.e., sched.c
 * Keep changes to a minimum. 
 *
 * Copyright (C) 2002 George Dunlap
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef _RLOG_MIN_H
#define _RLOG_MIN_H

#define ENTRY_PUT_USER 15
#define REVIRT_NR_PFCTRS 8
#define REVIRT_NR_SWCTR 6
#define REVIRT_NR_EX 24
//#define REVIRT_NR_PFCTRS 2

#ifndef __KERNEL__
typedef unsigned long long u64;
#endif

struct rlog_put_user_entry {
        short type;
        u64 xx;
        unsigned long pptr;
        short ssize, rretval;
        int pid, syscall;
};

int revirt_write_log(char * data, int type, int len);
void ztrace_debug_pause(void);



struct revirt_tsk_s {
	struct task_struct * self;
	int current_syscall;
	//int wait;
	struct task_struct * sched;
	struct perfctr_s perfctr[REVIRT_NR_PFCTRS];
	int ecount[REVIRT_NR_EX];
	/* replace with swcounter[] or something */
	/*
	 * 0: interrupts
	 * 1: exceptions w/o an error_code
	 * 2: exceptions w/ an error code
	 */
	unsigned int swctr[REVIRT_NR_SWCTR];
#if 0
	unsigned int intr;
	unsigned int ex;
	int nrex;
#endif	
	unsigned long nrxuser;
	unsigned long nrsyscalls;
};

#endif
