#include "umnet.h"

void
umnet_genirq(unsigned int nr)
{
	extern void call_isa_irq(unsigned int);
	DEBUG("generate irq %d for eth%d\n", umnet_irqs[nr], nr);
	call_isa_irq(umnet_irqs[nr]);
}

inline unsigned char /* FIXME MULTICAST */
umnet_multicast(unsigned int nr, unsigned char *buf)
{
	return 0;
}

inline unsigned char
umnet_my_mac(unsigned int nr, unsigned char *buf)
{
#define MAC card[nr].host[card[nr].myself].mac
	if (memcmp(buf, &MAC[0], 6) == 0)
		return 1;
	else
		return 0;
}

inline unsigned char
umnet_broadcast(unsigned int nr, unsigned char *buf)
{
	static unsigned char broadcast[6] = {
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff
	};

	if (memcmp(buf, &broadcast, sizeof(broadcast)) == 0)
		return 1;
	else
		return 0;
}

unsigned int
umnet_get_input(unsigned int nr)
{
	struct lotol_sockaddr_in from;
	unsigned int fromlen;
	int len;
	unsigned char buf[2048];
	struct umnet_e8390_pkt_hdr *hdr =
		(struct umnet_e8390_pkt_hdr *) &buf[0];

	assert(card[nr].myself != -1);

	fromlen = sizeof(from);
	len = lotol_recvfrom(
			card[nr].fd,
			&buf[sizeof(struct umnet_e8390_pkt_hdr)],
			sizeof(buf) - sizeof(struct umnet_e8390_pkt_hdr),
			0,
			(struct lotol_sockaddr *) &from,
			&fromlen);
	if ( 
		   len < 0
		&& errno != LOTOL_EAGAIN
		&& errno != LOTOL_ECONNREFUSED
		&& errno != LOTOL_EIO
	   ){
		printk(
			"mail this to sithglan@stud.uni-erlangen.de"
			" card[%d].fd = %d; len = %d; errno = %d\n",
			nr, card[nr].fd, len, errno
		      );
	}

	if (len <= 0)
		return 0;

	if (!(card[nr].rxcr & E8390_RXCONFIG))
		return 0;

#if DEBUGGING
	if (card[nr].rxcr & PROMISCUOUS) {
		DEBUG("%s", "PROMISC\n");
	}
	if (umnet_my_mac(nr, &buf[sizeof(struct umnet_e8390_pkt_hdr)])) {
		DEBUG("%s", "my_mac\n");
	}
	if (umnet_broadcast(nr, &buf[sizeof(struct umnet_e8390_pkt_hdr)])) {
		DEBUG("%s", "broadcast\n");
	}
#endif

#define SIZEOF_E8390_HDR sizeof(struct umnet_e8390_pkt_hdr)

	if (!0
			&& !umnet_my_mac(nr, &buf[SIZEOF_E8390_HDR])
			&& !(card[nr].rxcr & PROMISCUOUS)
			&& !umnet_broadcast(nr, &buf[SIZEOF_E8390_HDR])
			&& !umnet_multicast(nr, &buf[SIZEOF_E8390_HDR])
	   )
		return 0;

	while (len < 60) {
		card[nr].tbuf[sizeof(struct umnet_e8390_pkt_hdr) + len++] = 0;
	}

	assert( NESM_START_PG <= card[nr].curpag
	     && card[nr].curpag < NESM_STOP_PG);

	hdr->count  = len + sizeof(struct umnet_e8390_pkt_hdr);
	hdr->status = ENRSR_RXOK; /* Received a good packet */
	hdr->next   = card[nr].curpag + 1 + ((len + 4) >> 8);

#if 0
	DEBUG(
			"1=%d; 2=%d; 3=%d; 4=%d; 5=%d; 6=%d; 7=%d;\n",
			(card[nr].curpag - 0x4c) * 256,
			0,
			(NESM_STOP_PG - card[nr].curpag) * 256,
			0,
			(NESM_STOP_PG - card[nr].curpag) * 256,
			(len + sizeof(struct umnet_e8390_pkt_hdr))
			- ((NESM_STOP_PG - card[nr].curpag) * 256),
			0x4c + 1 + (NESM_STOP_PG - hdr->next)
	     );
	DEBUG("card[nr].curpag = 0x%02x; hdr->next = 0x%02x\n",
			card[nr].curpag, hdr->next);

#endif
	if (hdr->next < NESM_STOP_PG) { /* standard case */
		memcpy(
				&card[nr].rbuf[(card[nr].curpag - 0x4c) * 256],
				&buf[0],
				len + sizeof(struct umnet_e8390_pkt_hdr)
		      );

	} else if (hdr->next == NESM_STOP_PG) { /* reaches and fits into end */
		hdr->next = 0x4c;
		memcpy(
				&card[nr].rbuf[(card[nr].curpag - 0x4c) * 256],
				&buf[0],
				len + sizeof(struct umnet_e8390_pkt_hdr)
		      );

	} else {                  /* ring buffer reaches but !fits into end */
		hdr->next = 0x4c + (hdr->next - NESM_STOP_PG);
		memcpy(
				&card[nr].rbuf[(card[nr].curpag - 0x4c) * 256],
				&buf[0],
				((NESM_STOP_PG - card[nr].curpag) * 256)
		      );
		memcpy(
				&card[nr].rbuf[0],
				&buf[(NESM_STOP_PG - card[nr].curpag) * 256],
				(len + sizeof(struct umnet_e8390_pkt_hdr))
				- ((NESM_STOP_PG - card[nr].curpag) * 256)
		      );
	}

	card[nr].curpag   = hdr->next;

	assert(NESM_START_PG <= card[nr].curpag
	    && card[nr].curpag < NESM_STOP_PG);

#if 0
	DEBUG("card[nr].curpag = 0x%02x; hdr->next = 0x%02x\n",
			card[nr].curpag, hdr->next);
#endif
	card[nr].isr      |= ENISR_RX;
	card[nr].rsr       = ENRSR_RXOK; /* no errors */

	if (card[nr].imr & PRXE)
		umnet_genirq(nr);

	return 1;
}

void umnet_prom(unsigned int nr)
{
	memcpy(&card[nr].rbuf[0], &card[nr].prom[0], sizeof(card[nr].prom));
	card[nr].start = 0x4C00;
}

unsigned char
umnet_page1_inb(unsigned int nr, unsigned short port)
{
	unsigned char value;

	switch (port){
	case EN1_MAC0:   /* 0x01 */
		value = card[nr].mac0;
		break;
	case EN1_MAC1:   /* 0x02 */
		value = card[nr].mac1;
		break;
	case EN1_MAC2:   /* 0x03 */
		value = card[nr].mac2;
		break;
	case EN1_MAC3:   /* 0x04 */
		value = card[nr].mac3;
		break;
	case EN1_MAC4:   /* 0x05 */
		value = card[nr].mac4;
		break;
	case EN1_MAC5:   /* 0x06 */
		value = card[nr].mac5;
		break;
	case EN1_CURPAG: /* 0x07 */
		value = card[nr].curpag;
		break;
	case EN1_MULT0:  /* 0x08 */
		value = card[nr].mult0;
		break;
	case EN1_MULT1:  /* 0x09 */
		value = card[nr].mult1;
		break;
	case EN1_MULT2:  /* 0x0a */
		value = card[nr].mult2;
		break;
	case EN1_MULT3:  /* 0x0b */
		value = card[nr].mult3;
		break;
	case EN1_MULT4:  /* 0x0c */
		value = card[nr].mult4;
		break;
	case EN1_MULT5:  /* 0x0d */
		value = card[nr].mult5;
		break;
	case EN1_MULT6:  /* 0x0e */
		value = card[nr].mult6;
		break;
	case EN1_MULT7:  /* 0x0f */
		value = card[nr].mult7;
		break;
	default: /* NOT REACHED */
		assert(0);
		break;
	} /* switch(port); */

#if DEBUGGING
	if (port < (sizeof(umnet_page1) / sizeof(umnet_page1[0]))){
		DEBUG("0x%02x from %s\n", value, umnet_page1[port].txt);
	} else {
		DEBUG("0x%02x from 0x%02x\n", value, port);
	}
#endif

	return value;
}
	     

unsigned char
umnet_page0_inb(unsigned int nr, unsigned short port)
{
	unsigned char value;

	switch (port){
	case EN0_BOUNDARY: /* 0x03 something like a read pointer R/W */
		value = card[nr].boundary;
		break;
	case EN0_TSR: /* 0x04 Transmit status reg RD */
		value = card[nr].tsr;
		break;
	case EN0_ISR: /* 0x07 */
		value = card[nr].isr;
		break;
		/* statistics : Don't forget ... counter is reseted when read */
	case EN0_COUNTER0: /* 0x0d */ /* Rcv alignment error counter RD */
		value = 0; /* FIXME */
		break;
	case EN0_COUNTER1: /* 0x0e */ /* Rcv CRC error counter RD */
		value = 0; /* FIXME */
		break;
	case EN0_COUNTER2: /* 0x0f */ /* Rcv missed frame error counter RD */
		value = 0; /* FIXME */
		break;
	default:
		/* NOT REACHED */
		DEBUG("umnet_inb: read from 0x%02x\n", port); 
		assert(0);
		break;
	} /* switch(port) */

#if DEBUGGING
	if (port < (sizeof(umnet_page0_in) / sizeof(umnet_page0_in[0]))){
		DEBUG("0x%02x from %s\n", value, umnet_page0_in[port].txt);
	} else {
		DEBUG("0x%02x from 0x%02x\n", value, port);
	}
#endif
	return value;
}

unsigned char
umnet_inb(unsigned int nr, unsigned short port)
{
	unsigned char value;

	if (card[nr].myself == -1) { /* identity crise (do not exists) */
		value = 1; /* nope I am not a cleared counter */

	} else if (!port){                       /* CMD is for all pages */
	       value = card[nr].cmd;
	       DEBUG("0x%02x  to  %s\n", value, umnet_page1[port].txt);

	} else if (port == NE_DATAPORT) {        /* DATAPORT 0x10 */
		assert(0 < card[nr].count);

		if (0x8000 <= card[nr].start) {
			card[nr].start = card[nr].start - 0x3400;
		}

		value = card[nr].rbuf[card[nr].start - 0x4C00];

		card[nr].start++;
		card[nr].count--;

		if (!card[nr].count) {
			card[nr].isr |= ENISR_RDC;
			if (card[nr].imr & RDCE){
				umnet_genirq(nr);
			}
		}

	} else if (port == NE_RESET) {           /* RESET 0x1f */
		value = 0; /* maybe FIXME */
		DEBUG("%s", "read on NE_RESET\n");

	} else if (NE_DATAPORT < port && port < NE_RESET) {/* NOTHING IN HERE */
		assert(0);

	} else if (card[nr].cmd & E8390_PAGE2) { /* PAGE2 debug purposes only */
		assert(0);

	} else if (card[nr].cmd & E8390_PAGE1) {   /* PAGE1 */
		value = umnet_page1_inb(nr, port);

	} else {                                   /* PAGE0 */
		value = umnet_page0_inb(nr, port);
	}

	return value;
}

void 
umnet_page0_outb(unsigned int nr, unsigned char value, unsigned short port)
{
#if DEBUGGING
	if (port < (sizeof(umnet_page0_out) / sizeof(umnet_page0_out[0]))){
		DEBUG("0x%02x  to  %s\n", value, umnet_page0_out[port].txt);
	} else {
		DEBUG("0x%02x  to  0x%02x\n", value, port);
	}
#endif

	switch (port) {
	case EN0_STARTPG:  /* 0x01 */
	case EN0_STOPPG:   /* 0x02 */
		/* always the same FIXME make it configureable anyway */
		break;
	case EN0_BOUNDARY: /* 0x03 */
		card[nr].boundary = value;
		break;
	case EN0_TPSR:     /* 0x04 */
		card[nr].tpsr = value;
		break;
	case EN0_TCNTLO:   /* 0x05 */ /* tx byte count */
		card[nr].count = value;
		break;
	case EN0_TCNTHI:   /* 0x06 */
		card[nr].count |= (value << 8);
		DEBUG("TCNT count = %d\n", card[nr].count);
		break;
	case EN0_ISR:      /* 0x07 */
		card[nr].isr &= ~value;
		break;
	case EN0_RSARLO:   /* 0x08 */ /* Remote start address */
		card[nr].start = value;
		break;
	case EN0_RSARHI:   /* 0x09 */
		card[nr].start |= (value << 8);
		DEBUG("RSAR start = %d\n", card[nr].start);
		break;
	case EN0_RCNTLO:   /* 0x0a */ /* Remote byte counter */
		card[nr].count = value;
		break;
	case EN0_RCNTHI:   /* 0x0b */
		card[nr].count |= (value << 8);
		DEBUG("RCNT count = %d\n", card[nr].count);
		break;
	case EN0_RXCR:    /* 0x0c */
		card[nr].rxcr = value;
#if DEBUGGING
		if (card[nr].rxcr == E8390_RXCONFIG){
			DEBUG("%s\n",
					"EN0_RXCR: broadcasts,"
					"no multicast,errors");

		} else if (card[nr].rxcr == E8390_RXOFF) {
			DEBUG("%s\n", "EN0_RXCR: Accept no packets");
		}
#endif
		break;
	case EN0_TXCR:    /* 0x0d */
		card[nr].txcr = value;
#if DEBUGGING
		if (card[nr].txcr == E8390_TXCONFIG) {
			DEBUG("%s\n", "transmitter on");
		} else {
			DEBUG("%s\n", "transmitter off");
		}
#endif
		break;

	case EN0_DCFG:    /* 0x0e */
		card[nr].dcfg = value;
		break;
	case EN0_IMR:      /* 0x0f */
		card[nr].imr = value;
		if (card[nr].imr && card[nr].isr)
			umnet_genirq(nr);
		break;

	default: /* NOT REACHED */
		assert(0);
		break;
	} /* switch */
}

void
umnet_page1_outb(unsigned int nr, unsigned char value, unsigned short port)
{
	switch (port){
	case EN1_MAC0:   /* 0x01 */
		card[nr].mac0   = value;
		break;
	case EN1_MAC1:   /* 0x02 */
		card[nr].mac1   = value;
		break;
	case EN1_MAC2:   /* 0x03 */
		card[nr].mac2   = value;
		break;
	case EN1_MAC3:   /* 0x04 */
		card[nr].mac3   = value;
		break;
	case EN1_MAC4:   /* 0x05 */
		card[nr].mac4   = value;
		break;
	case EN1_MAC5:   /* 0x06 */
		card[nr].mac5   = value;
		break;
	case EN1_CURPAG: /* 0x07 */
		card[nr].curpag = value;
		break;
	case EN1_MULT0:  /* 0x08 */
		card[nr].mult0  = value;
		break;
	case EN1_MULT1:  /* 0x09 */
		card[nr].mult1  = value;
		break;
	case EN1_MULT2:  /* 0x0a */
		card[nr].mult2  = value;
		break;
	case EN1_MULT3:  /* 0x0b */
		card[nr].mult3  = value;
		break;
	case EN1_MULT4:  /* 0x0c */
		card[nr].mult4  = value;
		break;
	case EN1_MULT5:  /* 0x0d */
		card[nr].mult5  = value;
		break;
	case EN1_MULT6:  /* 0x0e */
		card[nr].mult6  = value;
		break;
	case EN1_MULT7:  /* 0x0f */
		card[nr].mult7  = value;
		break;
	default: /* NOT REACHED */
		assert(0);
		break;
	} /* switch(port); */

#if DEBUGGING
	if (port < (sizeof(umnet_page1) / sizeof(umnet_page1[0]))){
		DEBUG("0x%02x  to  %s\n", value, umnet_page1[port].txt);
	} else {
		DEBUG("0x%02x  to  0x%02x\n", value, port);
	}
#endif
	return;
}

void
umnet_xmit(unsigned int nr)
{
	struct lotol_sockaddr_in to;
	int i;
	int ret;

	for (i = 0; i < sizeof(card[nr].host) / sizeof(card[nr].host[0]); i++) {
		if (i == card[nr].myself)
			continue;
		if (card[nr].host[i].addr == 0
				|| card[nr].host[i].port == 0)
			continue;
		memset(&to, 0, sizeof(to));
		to.sin_family = LOTOL_AF_INET;
		to.sin_port = lotol_htons(card[nr].host[i].port);
		to.sin_addr = lotol_htonl(card[nr].host[i].addr);
		ret = lotol_sendto(
				card[nr].fd,
				&card[nr].tbuf[(card[nr].tpsr - 0x40) * 256],
				card[nr].count,
				0,
				(struct lotol_sockaddr *) &to,
				sizeof(to)
				);

		if ( 
				ret < 0
				&& errno != LOTOL_EAGAIN
				&& errno != LOTOL_ECONNREFUSED
				&& errno != LOTOL_EIO
		   ){
			printk(
					"report to sithglan@stud.uni-erlangen.de"
					"xmit of packet failed: ret = %d; errno = %d\n",
					ret, errno
			      );
		}
	}
	/* This is needed because the NIC has to pad packages smaller than 60
	 * with zeros */
	memset(&card[nr].tbuf[(card[nr].tpsr - 0x40) * 256], 0, card[nr].count);

	card[nr].count = 0;

	card[nr].isr |= ENISR_TX;    /* intr reason rcvd packet w.o. error */
	card[nr].tsr  = ENTSR_PTX;  /*  Packet transmitted without error  */

	if (card[nr].imr & PTXE) {
		umnet_genirq(nr);
	}
}

void
umnet_outb(unsigned int nr, unsigned char value, unsigned short port)
{
	if (card[nr].myself == -1){ /* does not exist */
		/* nothing todo */
		
	} else if (!port){
		card[nr].cmd = value;
		if (card[nr].cmd == (E8390_RREAD+E8390_START)) {
			if (!card[nr].start)
				umnet_prom(nr);
			if (card[nr].imr == 0x50) /* FIXME -- Not really */
				umnet_genirq(nr);
		} else if (card[nr].cmd == E8390_NODMA+E8390_TRANS+E8390_START) {
			umnet_xmit(nr);
		}
		DEBUG("0x%02x  to  %s\n", value, umnet_page1[port].txt);

	} else if (port == NE_DATAPORT) {        /* DATAPORT 0x10 */
		assert(0 < card[nr].count);
		card[nr].tbuf[card[nr].start - 0x4000] = value;
		card[nr].start++;
		card[nr].count--;

		if (!card[nr].count)
			card[nr].isr |= ENISR_RDC; /* remote dma complete */

	} else if (port == NE_RESET) {           /* RESET 0x1f */
		DEBUG("%s\n", "reset received");
		card[nr].isr |= ENISR_RESET;

	} else if (NE_DATAPORT < port && port < NE_RESET) { /* NOTHING HERE */
		assert(0);

	} else if (card[nr].cmd & E8390_PAGE2) { /* PAGE2 debug purposes only */
		assert(0);

	} else if (card[nr].cmd & E8390_PAGE1) { /* PAGE1 */
		umnet_page1_outb(nr, value, port);

	} else {                                   /* PAGE0 */
		umnet_page0_outb(nr, value, port);
	}

	return;
}

void
umnet_outsw(int nr, unsigned short port, unsigned char *addr,
		unsigned int count)
{
	count *= 2;

	memcpy(&card[nr].tbuf[card[nr].start - 0x4000], addr, count);

	card[nr].count -= count;
	card[nr].start += count;

	if (!card[nr].count) { /* FIXME check for interrupt or kick all RDC intr */
		card[nr].isr |= ENISR_RDC; /* remote dma complete */

		if (card[nr].imr & RDCE)
			umnet_genirq(nr);
	}
	DEBUG("%s", "umnet_outsw\n");
}

#if 1
void
umnet_insb(int nr, unsigned short port, unsigned char *addr,
		unsigned long count)
{
	for (; 0 < count; count--) {
		*addr++ = umnet_inb(nr, port);
	}
}

void
umnet_insw(int nr, unsigned short port, unsigned short *addr,
	    unsigned long count)
{
	DEBUG("%s", "umnet_insw\n");
	umnet_insb(nr, port, (unsigned char *) addr, count * 2);
}
#else /* This function is buggy! */
void
umnet_insw(int nr, unsigned short port, unsigned short *addr,
	    unsigned int count)
{
#define START ((card[nr].start - 0x4C00) * 256) 
#define RBUF  card[nr].rbuf
	unsigned char *p = (unsigned char *) addr;
	count           *= 2;
	if (0x8000 <= card[nr].start) {
		card[nr].start = card[nr].start - 0x3400;
	}

	if ((START + count) <= sizeof(RBUF)) {
		memcpy( p, &RBUF[START], count);
	} else {
		memcpy( p, &RBUF[START], sizeof(RBUF) - START);
		memcpy( p + (sizeof(RBUF) - START), &RBUF[0],
				count - (sizeof(RBUF) - START));
	}

	card[nr].count -= count;
	card[nr].start += count;

	if (!card[nr].count) {
		card[nr].isr |= ENISR_RDC;

		if (card[nr].imr & RDCE)
			umnet_genirq(nr);
	}

	DEBUG("%s", "umnet_insw\n");
}
#endif

void umnet_init_prom(unsigned int nr)
{
#define MYSELF card[nr].myself

	card[nr].prom[ 0] = card[nr].prom[ 1] = card[nr].host[MYSELF].mac[0];
	card[nr].prom[ 2] = card[nr].prom[ 3] = card[nr].host[MYSELF].mac[1];
	card[nr].prom[ 4] = card[nr].prom[ 5] = card[nr].host[MYSELF].mac[2];
	card[nr].prom[ 6] = card[nr].prom[ 7] = card[nr].host[MYSELF].mac[3];
	card[nr].prom[ 8] = card[nr].prom[ 9] = card[nr].host[MYSELF].mac[4];
	card[nr].prom[10] = card[nr].prom[11] = card[nr].host[MYSELF].mac[5];
	card[nr].prom[12] = card[nr].prom[13] = 0;       /* FIXME ? */
	card[nr].prom[14] = card[nr].prom[15] = 0;       /* FIXME ? */
	card[nr].prom[16] = card[nr].prom[17] = 0;       /* FIXME ? */
	card[nr].prom[18] = card[nr].prom[19] = 0;       /* FIXME ? */
	card[nr].prom[20] = card[nr].prom[21] = 5;       /* FIXME ? */
	card[nr].prom[22] = card[nr].prom[23] = 1;       /* FIXME ? */
	card[nr].prom[24] = card[nr].prom[25] = 28;      /* FIXME ? */
	card[nr].prom[26] = card[nr].prom[27] = 2;       /* FIXME ? */
	card[nr].prom[28] = card[nr].prom[29] = 87;      /* FIXME ? */
	card[nr].prom[30] = card[nr].prom[31] = 87;      /* FIXME ? */
}

void umnet_init_dev(unsigned int nr)
{
	
	int fd = FD_ETH_CONF(nr);
	int ret;
	char c;
	int i;

	ret = lotol_lseek_wrapper(fd, 0, SEEK_SET);
	if (ret < 0) /* does not exist */
		return;

	ret = lotol_read_wrapper(fd, &c, 1);
	if (ret < 0) /* file is empty */
		return;

	/* read `myself' */
	card[nr].myself = 0;
	if (ret != 1) c = '\0';
	while (('0' <= c && c <= '9')
			|| ('A' <= c && c <= 'F')
			|| ('a' <= c && c <= 'f')) {
		card[nr].myself *= 16;
		if ('0' <= c && c <= '9')
			card[nr].myself += c - '0';
		else if ('A' <= c && c <= 'F')
			card[nr].myself += c - 'A' + 10;
		else if ('a' <= c && c <= 'f')
			card[nr].myself += c - 'a' + 10;
		ret = lotol_read(fd, &c, 1);
		if (ret != 1) c = '\0';
	}

	/* read mac address / ip address/port */
	for (i = 0; i < sizeof(card[nr].host) / sizeof(card[nr].host[0]); i++) {
		int j;

		/* read mac address */
		for (j = 0; j < ETHER_ADDR_LEN; j++) {
			/* read digits */
			card[nr].host[i].mac[j] = 0;
			ret = lotol_read(fd, &c, 1);
			if (ret != 1) c = '\0';
			while (('0' <= c && c <= '9')
					|| ('A' <= c && c <= 'F')
					|| ('a' <= c && c <= 'f')) {
				card[nr].host[i].mac[j] *= 16;
				if ('0' <= c && c <= '9')
					card[nr].host[i].mac[j] += c - '0';
				else if ('A' <= c && c <= 'F')
					card[nr].host[i].mac[j] += c - 'A' + 10;
				else if ('a' <= c && c <= 'f')
					card[nr].host[i].mac[j] += c - 'a' + 10;
				ret = lotol_read(fd, &c, 1);
				if (ret != 1) c = '\0';
			}
		}

		/* read ip address */
		card[nr].host[i].addr = 0;
		ret = lotol_read(fd, &c, 1);
		if (ret != 1) c = '\0';
		while (('0' <= c && c <= '9')
				|| ('A' <= c && c <= 'F')
				|| ('a' <= c && c <= 'f')) {
			card[nr].host[i].addr *= 16;
			if ('0' <= c && c <= '9')
				card[nr].host[i].addr += c - '0';
			else if ('A' <= c && c <= 'F')
				card[nr].host[i].addr += c - 'A' + 10;
			else if ('a' <= c && c <= 'f')
				card[nr].host[i].addr += c - 'a' + 10;
			ret = lotol_read(fd, &c, 1);
			if (ret != 1) c = '\0';
		}

		/* read ip port */
		card[nr].host[i].port = 0;
		ret = lotol_read(fd, &c, 1);
		if (ret != 1) c = '\0';
		while (('0' <= c && c <= '9')
				|| ('A' <= c && c <= 'F')
				|| ('a' <= c && c <= 'f')) {
			card[nr].host[i].port *= 16;
			if ('0' <= c && c <= '9')
				card[nr].host[i].port += c - '0';
			else if ('A' <= c && c <= 'F')
				card[nr].host[i].port += c - 'A' + 10;
			else if ('a' <= c && c <= 'f')
				card[nr].host[i].port += c - 'a' + 10;
			ret = lotol_read(fd, &c, 1);
			if (ret != 1) c = '\0';
		}
	} /* for (i < sizeof(card[nr].host) / sizeof(card[nr].host[0])) */

	DEBUG("%s", "initalized\n");

	card[nr].fd = FD_ETH(nr);
	ret = lotol_fcntl(card[nr].fd, LOTOL_F_SETOWN, lotol_getpid());
	if (ret < 0) {
		LOTOL_OUT("umnet_init_dev: can't set owner for eth%d\n", nr);
		/* (void) lotol_close(umn->fd); */
		return;
	}
	umnet_init_prom(nr);
}

#ifndef CONFIG_TUN_TAP
void
umeth_interrupt(void) /* FIXME nameing convention umnet_interrupt */
{
	unsigned int nr;

	for (nr = 0; nr < (sizeof(card) / sizeof(card[0])); nr++) {
		if (card[nr].myself != -1){
			while(umnet_get_input(nr)) /* do nothing */ ;
		}
	}
}

void umeth_init(void)
{
	unsigned int nr;
	for (nr = 0; nr < (sizeof(card) / sizeof(card[0])); nr++)
		umnet_init_dev(nr);
}
#endif
