/*
 * $Id: umppi.c,v 1.1.1.1 2003/05/27 21:45:37 root Exp $
 */

#include <linux/assert.h>
#include <asm/lotol.h>

#define PIT0		0
#define SPEAKERTIMER	2

static unsigned char portB;	/* 0x61 */
static unsigned char portC;	/* 0x62 */
static unsigned char control;	/* 0x63 */

void
umppi_clear_nme(void)
{
     portB &= ~0x20;
}

unsigned char
umppi_inb(unsigned short port)
{
	unsigned char value;

	value = 0xff;	/* FIXME HSHOEXER */

	switch (port) {
	case 0x00:
		if (umpit_get_timer(PIT0, SPEAKERTIMER) <= 0) {
			portB |= 0x20;
		}

		value = portB;
		break;

	case 0x01:
	case 0x02:
		break;

	default:
		assert(0);
	}

	return value;
}

void
umppi_outb(unsigned char value, unsigned short port)
{
	extern void umpit_set_gate(int, int);

	switch (port) {
	case 0x00:
		portB = value;

		if (portB & 0x01) {
			/* start speaker timer */
			umpit_set_gate(PIT0, SPEAKERTIMER);
			umppi_clear_nme();
		}

		break;

	case 0x01:
	case 0x02:
		break;

	default:
		assert(0);
	}
}

void
umppi_init(void)
{
	portB = 0;
	portC = 0;
	control = 0;
}
