/*
 * $Id: umvga.c,v 1.1.1.1 2003/05/27 21:45:37 root Exp $
 */
#include <asm/io.h>
#include <asm/lotol.h>
#include <asm/lotol_fdesc.h>

#define PEL_WRITE_MODE_REG 0x3c8
#define PEL_READ_MODE_REG 0x3c7
#define PEL_DATA_REG 0x3c9

#if 0
#define QFAIL_PAL
#endif

#ifdef QFAIL_PAL
#define PAL_OFFSET 32
#else
#define PAL_OFFSET 0
#endif

#define pal_map	((char *) VA_VIDEO_CHIP)


static void
handle_colregs(unsigned char value, unsigned short port)
{
	static short a_seq = 0;
	static unsigned char regno_inc = 0;
	static unsigned char red;
	static unsigned char green;
	static unsigned char blue;
	char *colregs;
#ifdef QFAIL_PAL
	long *pal_idx;
#endif

	switch(port) {
	case PEL_READ_MODE_REG:
		break;
	case PEL_WRITE_MODE_REG:
		a_seq = 0;
		regno_inc = value;
		break;
	case PEL_DATA_REG:
		switch(a_seq) {
		case 0:
			red = value << 2;
			a_seq++;
			break;
		case 1:
			green = value << 2;
			a_seq++;
			break;
		case 2:
			blue = value << 2;
#ifdef QFAIL_PAL
			pal_idx = (((long*)pal_map) + regno_inc/32) |
				  (1 << (31 - (regno_inc%32)));
#endif
			colregs = pal_map + PAL_OFFSET + regno_inc * 3;
			colregs[0] = red;
			colregs[1] = green;
			colregs[2] = blue;

			a_seq = 0;
			if(regno_inc == 255) regno_inc = 0;
			else regno_inc++;
			break;
		default:
			lotol_write(1, "panic: PEL_DATA_REG error\n", 26);
		}
	}
}

unsigned char
umvga_inb(unsigned short port)
{
	/* FIXME */
	static int value = 0x34567890;
	char buf[64];

	sprintf(buf, "umvga_inb: port=0x%04x\n", port);
	lotol_write(1, buf, strlen(buf));

	return (unsigned char) value++;
}

void
umvga_outb(unsigned char value, unsigned short port)
{
	if (PEL_READ_MODE_REG <= port && port <= PEL_DATA_REG) {
		handle_colregs(value, port);
	} else {
		char buf[64];

		sprintf(buf, "umvga_outb: value=0x%02x port=0x%04x\n",
				value, port);
		lotol_write(1, buf, strlen(buf));
	}
}

void
umvga_init(void)
{
}

/*
 * Local variables:
 * c-basic-offset: 8
 * End:
 */
