#ifndef _I386_LOTOL_FDESC_H
#define _I386_LOTOL_FDESC_H

#define FD_LOTOL_MIN	16

#define FD_CPU(nr)		(_FD_CPU0 + (nr))

#define FD_ETH_CONF(nr)		(_FD_ETH0_CONF + 2 * (nr))
#define FD_ETH(nr)		(_FD_ETH0 + 2 * (nr))

#define FD_FD_MEDIA(drive)	(_FD_FD0_MEDIA + (drive))

#define FD_HD_MODEL(drive)	(_FD_HDA_MODEL + 3 * (drive))
#define FD_HD_CONFIG(drive)	(_FD_HDA_CONFIG + 3 * (drive))
#define FD_HD_MEDIA(drive)	(_FD_HDA_MEDIA + 3 * (drive))

typedef enum { 
	FD_MAIN_MEMORY = FD_LOTOL_MIN,  /* 16 */
	FD_VIDEO_MEMORY, FD_VIDEO_CHIP,

	_FD_CPU0,	/* 19 */
	_FD_CPU1,
	_FD_CPU2,
	_FD_CPU3,
	_FD_CPU4,
	_FD_CPU5,
	_FD_CPU6,
	_FD_CPU7,
	_FD_CPU8,
	_FD_CPU9,
	_FD_CPU10,
	_FD_CPU11,
	_FD_CPU12,
	_FD_CPU13,
	_FD_CPU14,
	_FD_CPU15,
	_FD_CPU16,
	_FD_CPU17,
	_FD_CPU18,
	_FD_CPU19,
	_FD_CPU20,
	_FD_CPU21,
	_FD_CPU22,
	_FD_CPU23,
	_FD_CPU24,
	_FD_CPU25,
	_FD_CPU26,
	_FD_CPU27,
	_FD_CPU28,
	_FD_CPU29,
	_FD_CPU30,
	_FD_CPU31,

	FD_RTC,		/* 51 */

	FD_KEYBOARD,
	FD_DISPLAY,

	/* Ethernet */
	_FD_ETH0_CONF, _FD_ETH0,  /* 54,55 */
	_FD_ETH1_CONF, _FD_ETH1,  
	_FD_ETH2_CONF, _FD_ETH2,
	_FD_ETH3_CONF, _FD_ETH3,
	_FD_ETH4_CONF, _FD_ETH4,
	_FD_ETH5_CONF, _FD_ETH5,
	_FD_ETH6_CONF, _FD_ETH6,
	_FD_ETH7_CONF, _FD_ETH7,
	_FD_ETH8_CONF, _FD_ETH8,
	_FD_ETH9_CONF, _FD_ETH9,
	_FD_ETH10_CONF, _FD_ETH10,
	_FD_ETH11_CONF, _FD_ETH11,
	_FD_ETH12_CONF, _FD_ETH12,
	_FD_ETH13_CONF, _FD_ETH13,
	_FD_ETH14_CONF, _FD_ETH14,
	_FD_ETH15_CONF, _FD_ETH15,

	FD_TUNTAP_CONF,
	FD_TUNTAP,

	/* For pipes (from cpu to apic) */
	FD_TO_LAPIC0,
	FD_TO_LAPIC1,
	FD_TO_LAPIC2,
	FD_TO_LAPIC3,
	FD_TO_LAPIC4,
	FD_TO_LAPIC5,
	FD_TO_LAPIC6,
	FD_TO_LAPIC7,
	FD_TO_LAPIC8,
	FD_TO_LAPIC9,
	FD_TO_LAPIC10,
	FD_TO_LAPIC11,
	FD_TO_LAPIC12,
	FD_TO_LAPIC13,
	FD_TO_LAPIC14,
	FD_TO_LAPIC15,
	FD_TO_LAPIC16,
	FD_TO_LAPIC17,
	FD_TO_LAPIC18,
	FD_TO_LAPIC19,
	FD_TO_LAPIC20,
	FD_TO_LAPIC21,
	FD_TO_LAPIC22,
	FD_TO_LAPIC23,
	FD_TO_LAPIC24,
	FD_TO_LAPIC25,
	FD_TO_LAPIC26,
	FD_TO_LAPIC27,
	FD_TO_LAPIC28,
	FD_TO_LAPIC29,
	FD_TO_LAPIC30,
	FD_TO_LAPIC31,

	FD_FROM_CPU0,
	FD_FROM_CPU1,
	FD_FROM_CPU2,
	FD_FROM_CPU3,
	FD_FROM_CPU4,
	FD_FROM_CPU5,
	FD_FROM_CPU6,
	FD_FROM_CPU7,
	FD_FROM_CPU8,
	FD_FROM_CPU9,
	FD_FROM_CPU10,
	FD_FROM_CPU11,
	FD_FROM_CPU12,
	FD_FROM_CPU13,
	FD_FROM_CPU14,
	FD_FROM_CPU15,
	FD_FROM_CPU16,
	FD_FROM_CPU17,
	FD_FROM_CPU18,
	FD_FROM_CPU19,
	FD_FROM_CPU20,
	FD_FROM_CPU21,
	FD_FROM_CPU22,
	FD_FROM_CPU23,
	FD_FROM_CPU24,
	FD_FROM_CPU25,
	FD_FROM_CPU26,
	FD_FROM_CPU27,
	FD_FROM_CPU28,
	FD_FROM_CPU29,
	FD_FROM_CPU30,
	FD_FROM_CPU31,

	/* for memory mapped apics */
	FD_LAPIC0,
	FD_LAPIC1,
	FD_LAPIC2,
	FD_LAPIC3,
	FD_LAPIC4,
	FD_LAPIC5,
	FD_LAPIC6,
	FD_LAPIC7,
	FD_LAPIC8,
	FD_LAPIC9,
	FD_LAPIC10,
	FD_LAPIC11,
	FD_LAPIC12,
	FD_LAPIC13,
	FD_LAPIC14,
	FD_LAPIC15,
	FD_LAPIC16,
	FD_LAPIC17,
	FD_LAPIC18,
	FD_LAPIC19,
	FD_LAPIC20,
	FD_LAPIC21,
	FD_LAPIC22,
	FD_LAPIC23,
	FD_LAPIC24,
	FD_LAPIC25,
	FD_LAPIC26,
	FD_LAPIC27,
	FD_LAPIC28,
	FD_LAPIC29,
	FD_LAPIC30,
	FD_LAPIC31,
	FD_LAPIC32,

	/* the actually used file desc. */
	FD_APIC_MEMORY,
	FD_IOAPIC_MEMORY,

	/* Floppy */
	_FD_FD0_MEDIA,
	_FD_FD1_MEDIA,

	/* Harddisk */
	_FD_HDA_MODEL, _FD_HDA_CONFIG, _FD_HDA_MEDIA,  
	_FD_HDB_MODEL, _FD_HDB_CONFIG, _FD_HDB_MEDIA,  
	_FD_HDC_MODEL, _FD_HDC_CONFIG, _FD_HDC_MEDIA,  
	_FD_HDD_MODEL, _FD_HDD_CONFIG, _FD_HDD_MEDIA,
	_FD_HDE_MODEL, _FD_HDE_CONFIG, _FD_HDE_MEDIA,  
	_FD_HDF_MODEL, _FD_HDF_CONFIG, _FD_HDF_MEDIA,  
	_FD_HDG_MODEL, _FD_HDG_CONFIG, _FD_HDG_MEDIA,  
	_FD_HDH_MODEL, _FD_HDH_CONFIG, _FD_HDH_MEDIA,
	_FD_HDI_MODEL, _FD_HDI_CONFIG, _FD_HDI_MEDIA,  
	_FD_HDJ_MODEL, _FD_HDJ_CONFIG, _FD_HDJ_MEDIA,  
	_FD_HDK_MODEL, _FD_HDK_CONFIG, _FD_HDK_MEDIA,  
	_FD_HDL_MODEL, _FD_HDL_CONFIG, _FD_HDL_MEDIA

} sysfd_t;

/* needed for inline asm code in lilo.c */
#define FD_MAIN_MEMORY		FD_LOTOL_MIN


/*
 * physical addresses,
 * virtual addresses,
 * and sizes (as far as known at compile-time)
 */
/* FIXME VOSSI */
#define PA_CPU			/* not applicable */
#define VA_CPU			0x7fff0000
#define SZ_CPU			4096

#define PA_VIDEO_CHIP		/* not applicable */
#define VA_VIDEO_CHIP		(VA_CPU + SZ_CPU)
#define SZ_VIDEO_CHIP		4096

#define PA_RTC			/* not applicable */
#define VA_RTC			(VA_VIDEO_CHIP + SZ_VIDEO_CHIP)
#define SZ_RTC			4096

#define PA_MAIN_MEMORY_LOW	0
#define SZ_MAIN_MEMORY_LOW	0xa0000

#define PA_VIDEO_MEMORY_LOW	(PA_MAIN_MEMORY_LOW + SZ_MAIN_MEMORY_LOW)
#define SZ_VIDEO_MEMORY_LOW	(128*1024)

#define PA_BIOS_ADD_ON_CARDS	(PA_VIDEO_MEMORY_LOW + SZ_VIDEO_MEMORY_LOW)
#define SZ_BIOS_ADD_ON_CARDS	(128*1024)

#define PA_SYSTEM_BIOS		(PA_BIOS_ADD_ON_CARDS + SZ_BIOS_ADD_ON_CARDS)
#define SZ_SYSTEM_BIOS		(128*1024)

#define PA_MAIN_MEMORY_HIGH	(PA_SYSTEM_BIOS + SZ_SYSTEM_BIOS)
#define SZ_MAIN_MEMORY_HIGH	/* depends on total memory installed in the system */

#define PA_VIDEO_MEMORY_HIGH	(0xe0000000)
#define SZ_VIDEO_MEMORY_HIGH	/* depends on video memory installed in the system */

#define PA_IO_APIC		(0xfec00000)
#define SZ_IO_APIC		(0x1000)

#define PA_LOCAL_APIC		(0xfee00000)
#define SZ_LOCAL_APIC		(0x1000)

#endif /* _I386_FDESC_H */
