/*
 * $Id: umkbd.c,v 1.1.1.1 2003/05/27 21:45:53 root Exp $
 * vim:tabstop=8:shiftwidth=8:textwidth=72
 */

#include <assert.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/socket.h>

#include <termios.h>

#include "external_constants.h"
#include "lotol_fdesc.h"

#include "lilo.h"
#include "config.h"

struct termios termios_old;

void
umkeyboard_init(void)
{
        int ret;
	struct termios termios_new;

	/* Change the terminal settings, if stdin is a terminal.
	   isatty will fail if stdin is redirected from /dev/null -MAB */
	
	if ( isatty(0) ) {

		ret=tcsetpgrp(0, getpgid());
		assert(0 <= ret);

	        ret = tcgetattr(0, &termios_old);
		assert(0 <= ret);

		memcpy(&termios_new, &termios_old, sizeof(struct termios));
		
		termios_new.c_lflag &= ~(ECHO | ICANON | IEXTEN | ISIG);
		/* echo off, canonical mode off, extended input
		   processing off, signal chars off */
		
		termios_new.c_iflag &= ~(BRKINT | INLCR | ICRNL | IGNCR |
					 ISTRIP | IXON);
		/* no SIGINT on BREAK, NL-to-CR off, CR-to-NL off,
		   ignore CR off, input parity check off,
		   don't strip the 8th bit on input, ouput flow control off */
		
		termios_new.c_cflag &= ~(CSIZE | PARENB);
		/* clear size bits, parity checking off */
		
		termios_new.c_cflag |= CS8;
		/* set 8 bits/char */
		
		/* return instantly, even with no data */
		termios_new.c_cc[VMIN] = 0;
		termios_new.c_cc[VTIME] = 0;
		
		ret = tcsetattr(0, TCSAFLUSH, &termios_new);
		assert(0 <= ret);
	
	}

	/*
	int fd;
	struct sockaddr_in addr;
	int ret;

	// create socket
	fd = socket(PF_INET, SOCK_STREAM, 0);
	assert(0 <= fd && fd < FD_LOTOL_MIN);

	// connect to keyboard process
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = htonl(config.keyboard.ipaddr);
	addr.sin_port = htons(config.keyboard.ipport);
	ret = connect(fd, (struct sockaddr *) &addr, sizeof(addr));
	assert(0 <= ret);

	ret = dup2(fd, FD_KEYBOARD);
	assert(FD_KEYBOARD == ret);

	ret = close(fd);
	assert(0 <= ret);
	*/
}

void
umkeyboard_shutdown(void)
{
        int ret;

	if ( isatty(0) ) {
	        ret = tcsetattr(0, TCSAFLUSH, &termios_old);
		assert(0 <= ret);
	}
	
        /*
	int ret;

	ret = close(FD_KEYBOARD);
	assert(0 <= ret);
	*/
}
