/*
 * release.c
 *
 * If ever we have a replaying process orphaned and unable to run, 
 * this program will attach and detach, allowing it to execute to completion.
 */

/*
 * replay/demon.h includes linux/sched.h, which includes just about everything
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/unistd.h>
#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>




int ztrace(int command,int pid,unsigned long addr,void *data) {
	int ret;
	ret= syscall(__NR_ztrace, command, pid, addr, data);
	return ret;
}

int main(int argc, char * argv[]) {
	int i;
	if(argc < 2) {
		fprintf(stderr, "Usage: %s pid\n", argv[0]);
	}
	printf("Printing host kernel stack for pid %d\n", atoi(argv[1]));
	ztrace(ZTRACE_PRINTSTACK, atoi(argv[1]),0,0);
	return(0);
}
