#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/syscalls.h>

#define __NR_lexecve 231

void lexecve(char *iname,char **argv,char **env, char *logname) {
	int ret;
	asm volatile("int $0x80"
			: "=a" (ret)
			: "a" (__NR_lexecve) , "b" (iname),
			  "c" (argv), "d" (env), "S" (logname) );

	printf("lexecve returns. error code= %d\n",ret);
	printf("%s\n",strerror(-ret));
}


int main(int argc,char **argv) {
	extern char **environ;
	int pid, status=5;

	if((pid=vfork())) {
		waitpid(-1, &status, 0);
		printf("Child status %d\n", status);
		if(WIFEXITED(status)) {
			printf(" child exited normally, code=%d\n",
					WEXITSTATUS(status));
		}
	} else {
		lexecve(argv[1], argv+1, environ, argv[1]);
	}
	return 1;
}
