#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/unistd.h>

#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>

/* FIXME -- just for now */
#define ZTRACE_GETSTATE 8
#define ZTRACE_PEEK 18

int ztrace(int command,int pid,unsigned long addr,void *data) {
	int ret;
	ret= syscall(__NR_ztrace, command, pid, addr, data);
	return ret;
}

int main(int argc, char * argv[]) {
	struct ztrace_state_struct zt_state;
	int pid;
	unsigned long from, to, i, val;
	int incr=4, j;
	if(argc < 4) {
		fprintf(stderr, "Usage: %s pid from to\n", argv[0]);
		exit(1);
	}
	from=strtoul(argv[2], NULL, 0);
	to=strtoul(argv[3], NULL, 0);
	pid=atoi(argv[1]);

	if(to < from) {
		fprintf(stderr, "Bad args: from %x to %x\n", from, to);
	}
	if(ztrace(ZTRACE_GETSTATE, pid,0,&zt_state))
		perror("getstate");
	printf("Reading from %x to %x\n", from, to);
	for(i=from; i<to; i+=4) {
		if(ztrace(ZTRACE_PEEK, pid, i, &val)) {
			perror("ztrace_peek");
			break;
		}
		printf("0x%x: 0x%08x\t", i, val);
		for(j=0; j<4; j++) {
			char c;
			c = ((char *)(&val))[j];
			if(isprint(c))
				putchar(c);
			else
				putchar('.');
		}
		printf("\n");
 	}
	return(0);
}
