#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>

#if 0
int ztrace(int command,int pid,unsigned long addr,void *data) {
        int ret;
        ret= syscall(__NR_ztrace, command, pid, addr, data);
        return ret;
}
#endif

int main(int argc, char * argv[]) {
	int option=0, value=1;
	char * c;
	if(argc==2) {
		c=argv[1];
		if(*c=='-') {
			c++;
			value=0;
		} else if(*c == '+') {
			value=1; // default
			c++;
		}
		option= 1 << atoi(c);
		value *= option;
	} else if(argc == 3) {
		option=atoi(argv[1]);
		option |= REPLAY_OPT_VALUE;
		value=atoi(argv[2]);
	} else {
		fprintf(stderr, "Usage: %d option [value]\n");
		exit(1);
	}

	printf("Setting 0x%x to %d\n", option, value );
	if(ztrace(ZTRACE_SET_OPT, getpid(), option, value, 0) < 0) {
		perror("ztrace_set_opt");
	}
	return 0;
}
