#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>

#if 0
int ztrace(int command,int pid,unsigned long addr,void *data) {
        int ret;
        ret= syscall(__NR_ztrace, command, pid, addr, data);
        return ret;
}
#endif

int main(int argc, char * argv[]) {
	int n=1, networkfd=0;
	if(argc>1) {
		n=atoi(argv[1]);
	}
	if(argc > 2) {
		networkfd=atoi(argv[2]);
	}
	if(n)
		n=REPLAY_OPT_THROTTLE_NETWORK;

	printf("Setting THROTTLE_NETWORK to %d\n", n);
	if(ztrace(ZTRACE_SET_OPT, getpid(), 
			REPLAY_OPT_THROTTLE_NETWORK, n) < 0) {
		perror("ztrace_set_opt");
	}
	if(networkfd) {
		printf("Setting NETWORK_FD to %d\n", networkfd);
		if(ztrace(ZTRACE_SET_OPT, getpid(), REPLAY_OPT_NETWORKFD,
					networkfd) < 0) {
			perror("ztrace_set_opt");
		}
	}
	return 0;
}
